package me.km.databank;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Statement implements IStatement
{
    private final DataBank d;
    private PreparedStatement ps;
    private final String query;
    
    public Statement(DataBank d, String query) throws SQLException
    {
        this.d = d;
        this.query = query;
        ps = d.prepareStatement(query);
    }
    
    @Override
    public void validate() throws SQLException
    {
        if(ps.isClosed())
        {
            ps = d.prepareStatement(query);
        }
    }
    
    @Override
    public void close() throws SQLException
    {
        ps.close();
    }
    
    @Override
    public void setInt(int index, int i) throws SQLException
    {
        ps.setInt(index, i);
    }
    
    @Override
    public void setLong(int index, long l) throws SQLException
    {
        ps.setLong(index, l);
    }
    
    @Override
    public void setFloat(int index, float f) throws SQLException
    {
        ps.setFloat(index, f);
    }
    
    @Override
    public void setDouble(int index, double d) throws SQLException
    {
        ps.setDouble(index, d);
    }
    
    @Override
    public void setString(int index, String s) throws SQLException
    {
        ps.setString(index, s);
    }
    
    @Override
    public ResultSet executeQuery() throws SQLException
    {
        return ps.executeQuery();
    }
    
    @Override
    public void executeUpdate() throws SQLException
    {
        ps.executeUpdate();
    }
}
