package me.km.items;

import java.util.List;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

public class ItemKey extends ItemBase
{
    private final Item.ToolMaterial toolMaterial;
    
    public ItemKey(String name, String local, Item.ToolMaterial materialIn)
    {
        super(name, local);
        this.toolMaterial = materialIn;
        this.maxStackSize = 1;
        super.setCreativeTab(CreativeTabs.MISC);
    }
    
    public int getLockPickResistance()
    {
        return toolMaterial.getHarvestLevel() + 1;
    }
    
    @SideOnly(Side.CLIENT)
    @Override
    public void addInformation(ItemStack stack, World w, List<String> lore, ITooltipFlag flag) 
    {
        if(stack.hasDisplayName())
        {
            lore.set(0, TextFormatting.GREEN + getItemStackDisplayName(stack));
        }
        else
        {
            lore.set(0, TextFormatting.RED + getItemStackDisplayName(stack));
        }
    }
}
