package me.km.plots;

import me.kcm.events.FarmlandTrampleEvent;
import me.km.KajetansMod;
import net.minecraft.block.Block;
import net.minecraft.block.BlockDoor;
import net.minecraft.block.BlockButton;
import net.minecraft.block.BlockContainer;
import net.minecraft.block.BlockLever;
import net.minecraft.block.BlockFenceGate;
import net.minecraft.entity.Entity;
import net.minecraft.entity.boss.EntityDragon;
import net.minecraft.entity.boss.EntityWither;
import net.minecraft.entity.item.EntityItemFrame;
import net.minecraft.entity.passive.EntityVillager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.DimensionType;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.event.entity.EntityStruckByLightningEvent;
import net.minecraftforge.event.entity.living.LivingAttackEvent;
import net.minecraftforge.event.entity.player.AttackEntityEvent;
import net.minecraftforge.event.entity.player.FillBucketEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.world.BlockEvent;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class Protection
{
    private final static String PLOT_BYPASS = "plot.bypass";
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onBlockPlace(BlockEvent.PlaceEvent e)
    {
        EntityPlayer p = e.getPlayer();
        if(!KajetansMod.perms.hasPermission(p, PLOT_BYPASS) && !KajetansMod.plots.canBuild(e.getWorld(), e.getPos(), p))
        {
            e.setCanceled(true);
        }        
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onBlockBreak(BlockEvent.BreakEvent e)
    {
        EntityPlayer p = e.getPlayer();
        if(!KajetansMod.perms.hasPermission(p, PLOT_BYPASS) && !KajetansMod.plots.canBuild(e.getWorld(), e.getPos(), p))
        {
            e.setCanceled(true);
        }  
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void WitherDragonProtection(EntityJoinWorldEvent e)
    {
        Class<? extends Entity> c = e.getEntity().getClass();
        if(c == EntityWither.class && e.getWorld().provider.getDimensionType() != DimensionType.NETHER)
        {
            e.setCanceled(true);
        }  
        else if(c == EntityDragon.class && e.getWorld().provider.getDimensionType() != DimensionType.THE_END)
        {
            e.setCanceled(true);
        } 
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onBucketFill(FillBucketEvent e)
    {
        EntityPlayer p = e.getEntityPlayer(); 
        RayTraceResult ray = e.getTarget();
        if(ray == null || KajetansMod.perms.hasPermission(p, PLOT_BYPASS))
        {
            return;
        }
        BlockPos pos = ray.getBlockPos();
        if(pos == null)
        {
            return;
        }
        if(!KajetansMod.plots.canBuild(e.getWorld(), pos, p))
        {
            e.setCanceled(true);
        }
    }
    
    // TODO:protection / entity with uuids
    /*@SubscribeEvent(priority = EventPriority.HIGHEST)
    public void EntityProtection(LivingAttackEvent e)
    {  
        e.getEntity().getUniqueID()
        EntityLivingBase ent = e.getEntityLiving();
        if(!this.getProtectionBank().isProtected(ent.getClass()))
        {
            return;
        }
        World w = ent.world;
        BlockPos pos = ent.getPosition();
        if(!this.getProtectionBank().hasProtection(w, pos) || 
            (ent instanceof EntityAnimal && this.getProtectionBank().hasTag(w, pos, "animal")))
        {
            return;
        } 
        
        if(e.getSource().getImmediateSource() != null)
        {
            EntityPlayer p = Utils.getDamager(e.getSource());
            if(p != null)
            {
                if(KajetansMod.perms.hasPermission(p, Permissions.PLOT_BYPASS) || this.getProtectionBank().canBuild(w, pos, p))
                {
                    return;
                }
                e.setCanceled(true);
            }
        }   
        e.setCanceled(true);
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void EntityProtectionPotion(ThrowableImpactEvent e)
    {
        if(e.getEntityThrowable() instanceof EntityPotion)
        {
            EntityPotion potion = (EntityPotion) e.getEntityThrowable();
            EntityLivingBase ent = potion.getThrower();
            if(ent instanceof EntityPlayer && !KajetansMod.perms.hasPermission(ent, Permissions.PLOT_BYPASS) &&
                !this.getProtectionBank().canBuild(potion.world, potion.getPosition(), (EntityPlayer) ent))
            {
                e.setCanceled(true);
            }
        }
    }*/
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onEntityHit(AttackEntityEvent e)
    {
        if(e.getTarget() instanceof EntityItemFrame)
        {
            EntityPlayer p = e.getEntityPlayer();
            if(!KajetansMod.perms.hasPermission(p, PLOT_BYPASS) && 
            !KajetansMod.plots.canBuild(p.world, e.getTarget().getPosition(), p))
            {
                e.setCanceled(true);
            }
        }
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void EntityProtectionPotion(EntityStruckByLightningEvent e)
    {
        e.setCanceled(true);
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onPlayerInteract(PlayerInteractEvent.LeftClickBlock e) 
    {
        EntityPlayer p = e.getEntityPlayer();
        if(KajetansMod.perms.hasPermission(p, PLOT_BYPASS))
        {
            return;
        }  
        Block b = e.getWorld().getBlockState(e.getPos()).getBlock();
        if(b == Blocks.FIRE && !KajetansMod.plots.canBuild(e.getWorld(), e.getPos(), p)) 
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void onPlayerInteract(PlayerInteractEvent.RightClickBlock e) 
    {
        EntityPlayer p = e.getEntityPlayer();
        if(KajetansMod.perms.hasPermission(p, PLOT_BYPASS))
        {
            return;
        }    
        Block b = e.getWorld().getBlockState(e.getPos()).getBlock();
        if(!(b instanceof BlockDoor) && 
                !(b instanceof BlockButton) && 
                !(b instanceof BlockContainer) && 
                !(b instanceof BlockLever) && 
                !(b instanceof BlockFenceGate) && 
                !KajetansMod.plots.canBuild(e.getWorld(), e.getPos(), p))
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void protectFromInteract(PlayerInteractEvent.EntityInteract e)
    {      
        EntityPlayer p = e.getEntityPlayer();
        if(!KajetansMod.perms.hasPermission(p, PLOT_BYPASS) && 
            !KajetansMod.plots.canBuild(e.getWorld(), e.getTarget().getPosition(), p))
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent(priority = EventPriority.HIGHEST)
    public void protectFromInteract(FarmlandTrampleEvent e)
    {      
        e.setCanceled(true);
    }
    
    @SubscribeEvent
    public void onAttackVillager(LivingAttackEvent e)
    { 
        if(e.getEntityLiving() instanceof EntityVillager && !e.getSource().isCreativePlayer())
        {
            e.setCanceled(true);
        }
    }
}
